
' .ApplicationSource CRV-Tools(1.0)'!

'From VisualWorks(R), Release 2.5 of September 26, 1995 on August 22, 1997 at 3:11:59 pm'!

'- user-strings of CRV-Tools(1.0) -'!

#('name' 'CRV-Tools' 'version' '1.0')!

'required applications for CRV-Tools(1.0)'!

Message
	selector: #checkRequired:
	argument: #()!

'- source of CRV-Tools(1.0) -'!



!Rectangle methodsFor: 'animation'!

animateTo: to steps: n block: block
	"make an zoom from self to 'to' in 'n' steps"

	| xZoom yZoom xExp yExp t rectangle |

	xZoom := to width / self width.
	yZoom := to height / self height.

	0 to: n do: [ :i |
		t := (i / n) asFloat.

		xExp := (t * xZoom ln) exp.
		yExp := (t * yZoom ln) exp.

		rectangle := self class
			left: (xZoom = 1.0
				ifTrue: [(1.0 - t) * self left + (t * to left)]
				ifFalse: [self left + ((xExp - 1.0) / (xZoom - 1.0) * (to left - self left))])
			top: (yZoom = 1.0
				ifTrue: [(1.0 - t) * self top + (t * to top)]
				ifFalse: [self top + ((yExp - 1.0) / (yZoom - 1.0) * (to top - self top))])
			width: xExp * self width
			height: yExp * self height.

		block numArgs = 1
			ifTrue: [block value: rectangle]
			ifFalse: [block value: rectangle value: i]
	].
	^to! !

!True methodsFor: 'converting'!

blendWith: aBoolean value: aNumber
	"blend self with aBoolean, only if self = aBoolean"

	aBoolean ifTrue: [^self].
	self unblendable! !

!ColorValue methodsFor: 'converting'!

blendWith: aColorValue value: aNumber
	"blend self with aColorValue, 0 means self and 1 means aColorValue"

	^self class
		red: (self red blendWith: aColorValue red value: aNumber)
		green: (self green blendWith: aColorValue green value: aNumber)
		blue: (self blue blendWith: aColorValue blue value: aNumber)! !

!SequenceableCollection methodsFor: 'enumerating'!

if: aBlock1 doWithSequence: aBlock2
	"Check every element of a SequenceableCollection with aBlock1. For all 'true regions'
	will aBlock2 evaluate once."

	self if: aBlock1 doWithSequence: aBlock2 doWithFirst: []!

if: aBlock1 doWithSequence: aBlock2 doWithFirst: aBlock3
	"Check every element of a SequenceableCollection with aBlock1. For all 'true regions'
	will aBlock2 evaluate once. aBlock3 will evaluate with the first element of the region
	(before aBlock2)"


	| flag start |

	flag := false.

	self keysAndValuesDo: [ :i :k |
		(aBlock1 value: k)
			ifTrue: [
				flag ifFalse:[
					flag := true.
					start := i.
					aBlock3 value: k.
				].
			]
			ifFalse: [
				flag ifTrue: [
					flag := false.
					aBlock2 value: (self copyFrom: start to: i - 1).
				].
			].
	].
	flag ifTrue: [aBlock2 value: (self copyFrom: start to: self size)].! !

!SequenceableCollection methodsFor: 'converting'!

blendWith: aSequenceableCollection value: aNumber
	"blend self with aSequenceableCollection, 0 means self and 1 means aSequenceableCollection"

	| s |

	self size ~= aSequenceableCollection size
		ifTrue: [self unblendable].

	s := OrderedCollection new: self size.
	self with: aSequenceableCollection do: [ :e1 :e2 |
		s add: (e1 blendWith: e2 value: aNumber)
	].
	^s! !

Stream subclass: #Random
	instanceVariableNames: 'seed increment modulus fmodulus multiplier '
	classVariableNames: 'DefaultGenerator DefaultRandom Increments MaxGenerator Moduli Multipliers '
	poolDictionaries: ''
	category: 'Magnitude-Numbers'!
Random comment:
'An instance of class Random provides an endless supply of random numbers.
We produce a uniform deviate in the half-open interval [0.0,1.0) using a
linear congruential generator.
seed increment modulus fmodulus multiplier 
See "Numerical Recipes" (W.H. Press, B.P. Flannery, S.A. Teukolsky, W.T. Vetterling;
Cambridge University Press 1986), pp. 191-199.

Instance Variables:
	seed			<Integer> the first of the series.
	increment		<Integer>
	modulus		<Integer>
	fmodulus		<Float>
	multiplier		<Integer>
					The recurrence parameters.

Class Variables:
	DefaultGenerator	<Integer> used to choose a generator if the client
						doesn''t select one.
	Increments			<Array of: Integer>
	MaxGenerator		<Integer> Highest numbered generator permitted;
						this is the length of the 3 arrays named below.
	Moduli				<Array of: Integer>
	Multipliers			<Array of: Integer>
						Constants for the recurrence parameters.  generator:
						selects from these, e.g. generator #2 uses:
							{Increments at: 2, Moduli at:2, Multipliers at: 2}.'!

!Random class methodsFor: 'instance creation'!

clearDefault

	^DefaultRandom := nil!

default

	DefaultRandom isNil ifTrue: [DefaultRandom := self new].
	^DefaultRandom!

next

	^self default next! !

!Point methodsFor: 'point functions'!

variate: r
	"returns a new Point with a random distance (max.: r) and a random angle"

	^self + (Point r: r * Random next theta: (2 * Float pi * Random next))! !

!Point methodsFor: 'converting'!

blendWith: aPoint value: aNumber
	"blend self with aPoint, 0 means self and 1 means aPoint"

	^(self x blendWith: aPoint x value: aNumber) @
		(self y blendWith: aPoint y value: aNumber)! !

!Point methodsFor: 'riemann'!

inverseRiemann1

	| r2 |
	
	(r2 := self dotProduct: self) = 0.0 ifTrue: [^self class zero].
	^self * (1.0 - (1.0 - r2) sqrt) / r2!

inverseRiemann2

	| r2 |
	
	(r2 := self dotProduct: self) = 0.0 ifTrue: [^self class zero].
	^self * (1.0 + (1.0 - r2) sqrt) / r2!

riemann

	^self * 2.0 / (1.0 + (self dotProduct: self))! !

!Double methodsFor: 'truncation and round off'!

cut
	"return only Doubles between 0.0d and 1.0d"
	"if you don't like this try: ^(self max: self class zero) min: self class unity"

	self < 0.0d ifTrue: [^0.0d].
	self > 1.0d ifTrue: [^1.0d].
	^self! !

!Float methodsFor: 'truncation and round off'!

cut
	"return only Floats between 0.0 and 1.0"
	"if you don't like this try: ^(self max: self class zero) min: self class unity"

	self < 0.0 ifTrue: [^0.0].
	self > 1.0 ifTrue: [^1.0].
	^self! !

!Number methodsFor: 'truncation and round off'!

roundToAPowerOfTwo
	"Answer the Power of 2 nearest the receiver."

	^1 bitShift: (self log: 2.0) rounded! !

!Number methodsFor: 'converting'!

blendWith: aNumber
	"blend self with aNumber (50%)"

	^self + aNumber * 0.5!

blendWith: a2ndNumber value: aNumber
	"blend self with a2ndNumber, 0 means self and 1 means a2ndNumber"

	^a2ndNumber - self * aNumber + self!

percent
	"Answer the receiver multiplied by 0.01"

	^0.01 * self! !

!Object methodsFor: 'initialize-release'!

initialize! !

!Object methodsFor: 'accessing'!

selfOrValueIfNil: aBlock

	^self! !

!Object methodsFor: 'converting'!

asString

	^self printString!

blendWith: anObject
	"blend self with anObject (50%)"

	^self blendWith: anObject value: 0.5!

blendWith: anObject value: aNumber
	"blend self with anObject, 0 means self and 1 means anObject"

	self unblendable! !

!Object methodsFor: 'error handling'!

unblendable
	"Answer an error notification."

	self error: 'impossible to blend'! !

!Filename class methodsFor: 'parsing'!

replaceAllSeparatorsWithDefault: filename

	| uglySeparators |

	uglySeparators := Set new.
	Filename allSubclassesDo: [:sub | uglySeparators add: sub separator].

	^filename collect: [:c |
		(uglySeparators includes: c) ifTrue: [self defaultClass separator] ifFalse: [c]
	]! !

!UndefinedObject methodsForUndefined: 'accessing'!

selfOrValueIfNil: aBlock

	^aBlock value! !

!UndefinedObject methodsForUndefined: 'converting'!

blendWith: anObject value: aNumber
	"blend self with anObject, only if self = anObject"

	anObject isNil ifTrue: [^self].
	self unblendable! !

!False methodsFor: 'converting'!

blendWith: aBoolean value: aNumber
	"blend self with aBoolean, only if self = aBoolean"

	aBoolean ifFalse: [^self].
	self unblendable! !


